#include "StdAfx.h"
#include "BuddyUser.h"
#include "UtilFunction.h"

CBuddyUser::~CBuddyUser(void)
{
	// NOTHING TO DO..
//	GT_PLOG("CBuddyUser::~CBuddyUser(void) %p \n", this);
}


/* static */
// IBuddy  ̿Ͽ GT_BUDDY_DATA ä ִ   ä!
bool CBuddyUser::CollectBuddyInfo(IBuddy *pBuddy, GT_BUDDY_DATA &sInfo)
{
	if(pBuddy == NULL)
		return false;

	sInfo.SetBuddy(true);
    sInfo.SetUserID(pBuddy->Id());
	//_COPYN_WCHAR(sInfo.strName, _T(""));

	//  ¥   !, sInfo ̹ ٸ Ӱ Ǿµ ⼭   ϱ !
	if(pBuddy->Nick() != NULL &&  wcscmp(pBuddy->Nick(), _T("")) != 0)
		sInfo.SetTalkName(pBuddy->Nick());

	sInfo.SetStatus((GTUserStatusType)(pBuddy->OnlineStatus()));
	sInfo.SetIPTStatus((NTIPTStatusType)(pBuddy->IPTStatus()));

	// Buddy Type
	BYTE nType = btNone;
	BYTE nTypeBits = pBuddy->BuddyType();

    if(nTypeBits & BTYPE_BL)
		nType |= btBlock;
	if(nTypeBits & BTYPE_WL)
		nType |= btWait;
	if(nTypeBits & BTYPE_FL)
		nType |= btBuddy;
    sInfo.SetNType(nType);

	//  Ʈ ־߸  ģ̴. (ģû ϴ ģ . UI ǥø ؾϴϱ..)
	if(nTypeBits & (BTYPE_WL | BTYPE_FL))
		sInfo.SetBuddy(true);
	else
		sInfo.SetBuddy(false);

    sInfo.SetOSType((GTOSType)pBuddy->GetOSType());  //original code missing this(compare to next CollectBuddyInfo),add by fujie 0515
    
	return true;
}


/* static */
// IBuddy  ̿Ͽ P_GT_BUDDY_DATA ä ִ   ä!
bool CBuddyUser::CollectBuddyInfo(IBuddy *pBuddy, P_GT_BUDDY_DATA &sInfo)
{
	if(pBuddy == NULL)
		return false;

	sInfo.SetBuddy(true);
	sInfo.SetUserID(pBuddy->Id());

	// [NOTICE]
	//  ̸ ¥ ̸ ƴϴ. 
	// "̵@" ˿ {̵} ̸ ̰ ִ. ! ǹ̾ . 
	// yet...
	//sInfo.strName = UserUtil::GetIDExceptDomain(sInfo.strUserID); // HJS

	//  ¥   !, sInfo ̹ ٸ Ӱ Ǿµ ⼭   ϱ !
	if(pBuddy->Nick() != NULL &&  wcscmp(pBuddy->Nick(), _T("")) != 0)
		sInfo.SetTalkName(pBuddy->Nick());

	// USE_BUDDYDATA_MOBILE_HASH
//	//  ¥   !, sInfo ̹ ٸ Ӱ Ǿµ ⼭   ϱ !
//	if(pBuddy->MobilePhoneHash() != NULL &&  strcmp(pBuddy->MobilePhoneHash(), "") != 0)
//		sInfo.strMobilePhoneHash = pBuddy->MobilePhoneHash();

	BYTE nStatus = pBuddy->OnlineStatus();
	sInfo.SetStatus((GTUserStatusType)pBuddy->OnlineStatus());
	sInfo.SetIPTStatus((NTIPTStatusType)pBuddy->IPTStatus());

	// Buddy Type
	BYTE nType = btNone;
	BYTE nTypeBits = pBuddy->BuddyType();

    if(nTypeBits & BTYPE_BL)
		nType |= btBlock;
	if(nTypeBits & BTYPE_WL)
		nType |= btWait;
	if(nTypeBits & BTYPE_FL)
		nType |= btBuddy;
    sInfo.SetNType(nType);

	//  Ʈ ־߸  ģ̴. (ģû ϴ ģ . UI ǥø ؾϴϱ..)
	if(nTypeBits & (BTYPE_WL | BTYPE_FL))
		sInfo.SetBuddy(true);
	else
		sInfo.SetBuddy(false);
	
	sInfo.SetOSType((GTOSType)pBuddy->GetOSType());
	return true;
}


const char* CBuddyUser::GetCustomData(void) const
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutex);
	if(m_pBuddy == NULL)
		return NULL;

	return m_pBuddy->GetCustomData();
}


int CBuddyUser::GetCustomDataSize(void) const
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutex);
	if(m_pBuddy == NULL)
		return 0;

	return m_pBuddy->GetCustomDataSize();
}

BYTE CBuddyUser::GetType(void) const
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutex);
	if(m_pBuddy == NULL)
		return 0;

	// Buddy Type
	BYTE nResult = btNone;
	BYTE nTypeBits = m_pBuddy->BuddyType();

    if(nTypeBits & BTYPE_BL)
		nResult |= btBlock;
	if(nTypeBits & BTYPE_WL)
		nResult |= btWait;
	if(nTypeBits & BTYPE_FL)
		nResult |= btBuddy;

	return nResult;
}

LPCWSTR CBuddyUser::GetDisplayName(void) const
{
	return m_sData.GetDisplayName().c_str();
}

bool CBuddyUser::IsOnline(void) const
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutex);
	if(NULL == m_pBuddy)
	{
		bool bOnline = (m_sData.GetStatus() != ustOFFLINE);
		return bOnline;
	}
	
	// Buddy OnlineStatus
	switch(m_pBuddy->OnlineStatus())
	{
	case ST_OFFLINE:
		return false;
	default:
		break;
	}
	return true;
}


bool CBuddyUser::IsBuddy(void) const
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutex);
	if(m_pBuddy == NULL)
		return false;

	if(m_pBuddy->BuddyType() & (BTYPE_FL | BTYPE_WL))
		return true;

	return false;
}

//bool CBuddyUser::IsFakeBuddy(void) const
//{
//	return m_isFakeBuddy;
//}

bool CBuddyUser::IsBlock(void) const
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutex);
	if(m_pBuddy == NULL)
		return false;

	if(m_pBuddy->BuddyType() & BTYPE_BL)
		return true;
	return false;
}


bool CBuddyUser::IsWait(void) const
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutex);
	if(m_pBuddy == NULL)
		return false;
	if(m_pBuddy->BuddyType() & BTYPE_WL)
		return true;
	return false;
}

GTOSType CBuddyUser::GetOSType(void) const
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutex);
	if(m_pBuddy == NULL)
		return osUnknown;
	
	return (GTOSType)m_pBuddy->GetOSType();
}


void CBuddyUser::LoadData(const GT_BUDDY_UPDATABLE_DATA &userdata)
{
	P_GT_BUDDY_UPDATABLE_DATA sData;
	sData.Load(userdata);
	LoadData(sData);
}

void CBuddyUser::LoadData(const P_GT_BUDDY_UPDATABLE_DATA &userdata)
{
	// ּ  Valid üũ Ѵ!
	if(m_sData.GetGroupID()  >= 0)
    {
		m_sData.SetGroupID(userdata.nGroupID);
    }
	m_sData.SetAlias(userdata.strAlias);
}


void CBuddyUser::CollectData()
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutex);
	if(m_pBuddy)
	{
		CollectBuddyInfo(m_pBuddy, m_sData);
	}

    if(m_strTalkName.length() > 0)
        m_sData.SetTalkName(m_strTalkName);
    
    if(IsMobileUser())
    {
        m_sData.SetMobileUsage(true);
    }
    else{
        m_sData.SetMobileUsage(false);
    }
}

